#Darwish Electron Model.  Assumes a low field mobility has
#already been defined and $mun is the electron mobility.

#Model parameters
set DEB 3.61e7
set DEC 1.70e4
set DEtau 0.0233
set DEdelta 3.58e18
set DEA 2.58
set DEalpha 6.85e-21
set DEeta 0.0767
set DEkappa 1.7

#surface acoustic phonon scattering
#set DETpri [expr pow(($Temp/300.0),$DEkappa)]
set DETpri "((T/300.0)^$DEkappa)"
set DEfoo "(($DEB*$DETpri)/(trans(DevPsi)+1.0e-10))"
set DEfoo "($DEfoo+($DEC*(Donors+Acceptors+Hole)^$DEtau)/((trans(DevPsi)+1.0e-10)^([expr 1.0/3.0])))"
set DEmuac "($DEfoo*(1.0/$DETpri))"

#surface roughness scattering
set DEgamma "(($DEA+(($DEalpha*(Elec+Hole))/((Donors+Acceptors+Hole)^($DEeta)+1.0e-15))))"
set DEmusr "($DEdelta/((trans(DevPsi)+1e-20)^($DEgamma)+1.0e-20))"

# Combine using Mathiesson's rule
set DEfoo "(($mun)*($DEmuac)*($DEmusr)/(($mun)*($DEmuac)+($DEmuac)*($DEmusr)+($DEmusr)*($mun)))"
term name=DEmob add eqn=$DEfoo
set $mun "DEmob"
