
## Full Density Gradient Correction:
proc DGEquation { Lambda DevPsi } {
	set ni [pdbGetDouble Niobium Atoms]
	set Vt [pdbGetDouble DynamicConstants Vt]
	set m  [pdbGetDouble FundamentalConstants m]
	set q  [pdbGetDouble FundamentalConstants q]
	set hbar   [pdbGetDouble FundamentalConstants hbar]
	set DGConst  [expr 1e4*$q*($hbar)**2./12./$m/$Vt]
	return "$Lambda - $DGConst * grad($Lambda+$DevPsi) + $DGConst * dot( ($Lambda+$DevPsi) , ($Lambda+$DevPsi) ) / (2*$Vt)"
}
#puts [ DGEquation Lambda DevPsi ]

proc DGCarrier { DevPsi F Lambda gamma } {
	set Vt [pdbGetDouble DynamicConstants Vt]
	set ni [pdbGetDouble Niobium Atoms]
	return "$ni*(($DevPsi-$F)/$Vt + $Lambda*$gamma/$Vt + 1)"
}
#puts [ DGCarrier Lambda DevPsi F ]

