
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! this one use niobium parameters rather than the oxide
proc PoissonOxide { DevPsi } {
	set eps [pdbGetDouble FundamentalConstants eps]
	set q 	[pdbGetDouble FundamentalConstants q]
	set Atoms [pdbGetDouble Niobium Atoms];#!!!!!!!! all of these rely on nioium rather than the oxide parameters, should be updated in the future
	set ernb  [pdbGetDouble Niobium ernb];#!!!!!!!!!

	set eoxq [expr $eps*$ernb/$q];#!!!!!!!!!!!!!!!!!!!!!!! Permittivity of oxide per q, divide by q for Poisson's equation. Consider renaming
	#set eox [pdbGetDouble Niobium enb]

	return "$eoxq * grad($DevPsi)"
}
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

proc Poisson { DevPsi Elec } {
	set eps [pdbGetDouble FundamentalConstants eps]
	set q 	[pdbGetDouble FundamentalConstants q]
	set Atoms [pdbGetDouble Niobium Atoms]
	set ernb  [pdbGetDouble Niobium ernb]
	
	set enbq [expr $eps*$ernb/$q] ;# Permittivity of niobium per q, divide by q for Poisson's equation. Consider renaming!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	#set enb [pdbGetDouble Niobium enb]

	sel z= $Atoms name= Doping
	return "$enbq * grad($DevPsi) + Doping - $Elec"
}
# example
#puts [Poisson DevPsi Elec]
# pdbSetString Niob1 DevPsi Equation [Poisson DevPsi Elec]

proc PoissonInterface  { DevPsi RegionA RegionB thickness } {
	set eps  [pdbGetDouble FundamentalConstants eps]
	set q 	 [pdbGetDouble FundamentalConstants q]
	set erox [pdbGetDouble Oxide erox]
	
	set eoxq [expr $eps*$erox/$q]
	return "($DevPsi\($RegionB)-$DevPsi\($RegionA))/($thickness/$eoxq)" 
	#set eox [pdbGetDouble Oxide eox]
	#return "($DevPsi\($RegionB)-$DevPsi\($RegionA))/($thickness/$eox)" 
}

# example
#The average barrier thickness is 0.9 nm, m to cm 
# puts [PoissonInterface DevPsi Niob2 Niob1 [ expr 0.9e-9 * 100. ]]
# puts [PoissonInterface DevPsi Niob1 Niob2 [ expr 0.9e-9 * 100. ]]
# pdbSet Niob1_Niob2 DevPsi Niob2 Equation [PoissonInterface DevPsi Niob2 Niob1 [ expr 0.9e-9 * 100. ]]
# pdbSet Niob1_Niob2 DevPsi Niob1 Equation [PoissonInterface DevPsi Niob1 Niob2 [ expr 0.9e-9 * 100. ]]