
proc CheckValue { goldVal actual tol } {
	# the if statement checks if the actual value is too far away from the gold value
	if { $actual > [expr $goldVal+$tol] || $actual < [expr $goldVal-$tol] } {;
        puts "The values are too different!!!!"
		return 0
    } else {
        return 1
    }
}

proc CheckSweep { goldlist actualList tol } {
	# 1st if statement checks if the lists are equally long, if not, there is an error!
	if { [llength $goldlist] == [llength $actualList] } {
		# if the lists are equally long, we will step through them and compare each list element
		set location 0;												# we start at location 0
		foreach g $goldlist a $actualList {
			# checks if the difference between the respective list elements exceeds the tolerance. If so, the function is terminated
			if {$a > [expr $g+$tol] || $a < [expr $g-$tol] } { 
				puts "ERROR!!!\nThe lists values are too different at list location $location"
				return 0
			}
			incr location
		}
	} else {
		puts "The two lists have different length"
		return 0
	}
	return 1
}

	

proc ExampleListLoop {} {
	set samp1 "1 2 3 7 5"
	set samp2 "5 7 3 2 1"
	set testTol 1
	# tcl provides a foreach
	foreach i $samp1 l $samp2 {
		puts "$i $l"

	}
	puts "doen with foreach looping"

	# or just use a for loop for looping over two equal lists
	set ex "1 3 5 6"
	set ex2 "4 5 6 12 15"
	if { [llength $ex] == [llength $ex2] } {
		for { set i 0 } { $i < [llength $ex] } { incr i } {
			puts "[lindex $ex $i] [lindex $ex2 $i]"
		}
	} else {
		puts "Can't loop over two lists of different lengths easily"
	}
	
	# Example failure
	set ex2 "4 5 6 12"
	if { [llength $ex] == [llength $ex2] } {
		for { set i 0 } { $i < [llength $ex] } { incr i } {
			puts $i
			puts "[lindex $ex $i] [lindex $ex2 $i]"
		}
	} else {
		puts "Can't loop over two lists of different lengths easily"
	}

}


#ExampleListLoop