#Parameter values for Boron
set KHmumax 470.5
set KHmumin 44.9
set KHNref1 2.23e17
set KHalph1 0.719
set KHcD 0.21
set KHNrefD 4.0e20
set KHcA 0.50
set KHNrefA 7.2e20
set KHtheta_e 2.285
set KHtheta_h 2.247

#Klaussen's fit parameters
set KHme 1.0
set KHmh 1.258
set KHfcw 2.459
set KHfbh 3.828

# Lattice scattering 
set KHmuL "($KHmumax*(300.0/T)^$KHtheta_h)"

# Impurity and Elec Scattering.
set KHmuiN [expr "($KHmumax*$KHmumax/($KHmumax-$KHmumin))"]
set KHmuiN "($KHmuiN*(T/300.0)^(3.0*$KHalph1-1.5))"
set KHmuiC [expr "($KHmumax*$KHmumin/($KHmumax-$KHmumin))"]
set KHmuiC "($KHmuiC*(300.0/T)^0.5)"
set KHNsc "(Donors+Acceptors+Elec)"
set KHPBH "(1.36e20/Hole*$KHmh*(T/300.0)^2.0)"
set KHfoo "(1.0+1.0/($KHcD+($KHNrefA/$KHNsc)^2.0))"
term name=KHZ add eqn=$KHfoo
set KHPCW "(3.97e13*((1.0/(KHZ^3.0*$KHNsc))*(T/300.0)^3.0)^(2.0/3.0))"
set KHfoo "(1.0/($KHfcw/($KHPCW)+$KHfbh/($KHPBH)))"
term name=KHP add eqn=$KHfoo

set KHs1 0.89233
set KHs2 0.41372
set KHs3 0.19778
set KHs4 0.28227
set KHs5 0.005978
set KHs6 1.80618
set KHs7 0.72169
set KHfoo "(1.0-$KHs1/($KHs2+((T/300.0/$KHmh)^$KHs4)*(KHP))^$KHs3+$KHs5/((($KHmh*300.0/T)^$KHs7)*KHP)^$KHs6)"
term name=KH_G add eqn=$KHfoo

set KHr1 0.7643
set KHr2 2.2999
set KHr3 6.5502
set KHr4 2.3670
set KHr5 -0.01552
set KHr6 0.678
set KHfoo "(($KHr1*KHP^$KHr6+$KHr2+$KHr3*$KHmh/$KHme)/(KHP^$KHr6+$KHr4+$KHr5*$KHmh/$KHme))"
term name=KH_F add eqn=$KHfoo

set KHNsceff "(Acceptors+KH_G*Donors+Elec/KH_F)"

set KHfoo "($KHmuiN*$KHNsc/$KHNsceff*($KHNref1/$KHNsc)^$KHalph1+$KHmuiC*(Elec+Hole)/$KHNsceff)"
term name=KHmuDAh add eqn=$KHfoo

# Combine using Mathiesson's rule
set KHfoo "($KHmuL*KHmuDAh/($KHmuL+KHmuDAh))"
term name=KHmob add eqn=$KHfoo
set mup "KHmob"
