proc CtoK {C} {
	return (($C)+273.15)
}
proc KtoC {K} {
	return (($K)-273.15)
}

proc GenericProcs args {
  global ProcsDir FLXSHOME
  if { [expr [ string first -help $args ] != -1] } {
    return ""
  }
  set origProcs [info procs]
  if { [info exists ProcsDir] } {
    set FileDir $ProcsDir/Models/Generic/
  } else {
    set FileDir $FLXSHOME/TclLib/Device/floods/Generic/
  }

  uplevel 0 {source $FileDir/Laplace/laplace.tcl}
  uplevel 0 {source $FileDir/Poisson/poisson.tcl}

  uplevel 0 {source $FileDir/Transport/continuity.tcl}
  uplevel 0 {source $FileDir/Transport/statistics.tcl}
  uplevel 0 {source $FileDir/Transport/fields.tcl}
  uplevel 0 {source $FileDir/Transport/mathiessen.tcl}

  uplevel 0 {source $FileDir/Contacts/ohmic.tcl}
  uplevel 0 {source $FileDir/Contacts/gate.tcl}
  
  uplevel 0 {source $FileDir/B2BTunnel/simple.tcl}
  uplevel 0 {source $FileDir/B2BTunnel/schenk.tcl}
  
  uplevel 0 {source $FileDir/DensityGradient/DG.tcl}

  uplevel 0 {source $FileDir/Recombination/SRH.tcl}
  uplevel 0 {source $FileDir/Recombination/Auger.tcl}
  
}

GenericProcs
