
proc Laplace args {
  set name [lindex [info level 0] 0]
  lappend usage "$name er= potential=DevPsi"
  lappend usage {The relative permitivity (er) is unitless.}
  set returns {Laplace's equation tunneling alagator string}
  set description {Simple Laplace's equation $\epsilon_r\nabla\Phi= 0$}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set er [__GetValue $args er "$name Error: No relative permitivity (er) is given"]
  set potential [__GetValue $args potential ]
  if {$potential == ""} { set potential DevPsi }

  set q 1.602e-19
  set eps [expr $er * 8.85418e-14 / $q]

  return "$eps * grad($potential)"
}

