namespace eval Silicon {

proc BandGap args {
  set name [lindex [info level 0] 0]
  lappend usage "$name T="
  lappend usage {Temperature (T) is in Kelvin.}
  set returns {alagator string}
  set description {Temperature dependent band gap model.}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }

  set T [__GetValue $args T "Temperature parameter (T) in Kelvin required"]
  
  set Ebgn 6.92e-3;# eV
  set Nref 1.3e17;# /cm3

  # Temp dependent bandgap model
  set alpha 4.73e-4 ;# eV/K
  set beta 636.0 ;# K
  set Eg0 1.1696 ;# eV
  return "($Eg0-$alpha*$T^2/($T+$beta))" ;# eV
  
}


}
