source ../procs.tcl
source ../Stress/constants.tcl

window col= 2
foreach T "100 150 250 300 350 400" {
  set Vt ($k*$T/$q)
  set Nv_lh [ expr 2*( ( $m0*$mp_lh*$k*$T )/( 2*$pi*$hbar**2) )**1.5 /100**3 ]
  set Nv_hh [ expr 2*( ( $m0*$mp_hh*$k*$T )/( 2*$pi*$hbar**2) )**1.5 /100**3 ]
  for { set Na 1e14 } { $Na < 1e20 } { set Na [expr 2*$Na] } {
    set Activation 1
    for { set j 0 } { $j < 20 } { incr j } {
      set Activation0 $Activation
      set DevPsi [expr -$Vt*log(($Activation*$Na)/($Nv_lh+$Nv_hh))]
      set Activation [ActiveBoronTest $Na $DevPsi $T]/$Na
      puts [expr $Activation0-$Activation]
    }
    chart graph= DevPsi curve= $T xval= [expr log10($Na)] yval= $DevPsi title= "Intrensic fermi level vs Concentration at various temperatures" ylab= "Intrensic Level (eV)" xlab= "Carrier Concentration (log)"
    chart curve= $T xval= [expr log10($Na)] yval= $Activation title= "Ionization fraction vs Concentration at various temperatures" ylab= "Ionization fraction (unitless)" xlab= "Carrier Concentration (log)"
  }
}
gets stdin


