
proc SiProcs {{gen 0}} {
  global ProcsDir FLXSHOME
  set origProcs [info procs]
  if { [info exists ProcsDir] } {
    set FileDir $ProcsDir/Models/Silicon/
  } else {
    set FileDir $FLXSHOME/TclLib/Device/floods/Silicon/
  }
  uplevel 0 {source $FileDir/Mobility/Canali/canali.tcl}
  uplevel 0 {source $FileDir/Mobility/Cummings/Cummings.tcl}
  uplevel 0 {source $FileDir/Mobility/Klaassen/KlaassenNAs.tcl}
  uplevel 0 {source $FileDir/Mobility/Klaassen/KlaassenNP.tcl}
  uplevel 0 {source $FileDir/Mobility/Klaassen/KlaassenPB.tcl}
  uplevel 0 {source $FileDir/Mobility/Masetti/model.tcl}
  uplevel 0 {source $FileDir/Mobility/lombardi.tcl}
  
  uplevel 0 {source $FileDir/Hall/HallFactorTemp.tcl}
  
  uplevel 0 {source $FileDir/Strain/params.tcl}
  if { !$gen } {
    #SetSiliconStrainParams110
    Silicon::SetSiliconStrainParams
  }
  uplevel 0 {source $FileDir/Strain/HoleModels.tcl}
  uplevel 0 {source $FileDir/Strain/ElecModels.tcl}
  
  uplevel 0 {source $FileDir/Bandstructure/Nc.tcl}
  uplevel 0 {source $FileDir/Bandstructure/Nv.tcl}
  uplevel 0 {source $FileDir/Bandstructure/bandgap.tcl}
  uplevel 0 {source $FileDir/Bandstructure/Slotboom/models.tcl}
  
  uplevel 0 {source $FileDir/Avalanche/CrowellSze.tcl}
  uplevel 0 {source $FileDir/Avalanche/Lackner.tcl}
  uplevel 0 {source $FileDir/Avalanche/Okuto.tcl}
  uplevel 0 {source $FileDir/Avalanche/Selberherr.tcl}
  uplevel 0 {source $FileDir/Avalanche/UniBoNew.tcl}
  uplevel 0 {source $FileDir/Avalanche/UniBo.tcl}
  uplevel 0 {source $FileDir/Avalanche/vanOberstraeten.tcl}
  
  uplevel 0 {source $FileDir/Carrier/ActiveBoron.tcl}
  uplevel 0 {source $FileDir/Carrier/ActivePhosphorus.tcl}

  uplevel 0 {source $FileDir/Equations.tcl}
  
  if { !$gen } {
    puts [ccolor::replace "<cb>Loaded procedures: </>"]
    set procs [info procs]
    foreach x $procs {
      set unique 1
      foreach y $origProcs {
        if { $y == $x } { set unique 0 }
      }
      if { $unique } { puts [ccolor::replace "<g>\t$x</>"]  }
    }
  }
  
}
# SiProcs


