
proc Hole0Stress {  } {
  global ModelsDirectory
  #this procedure modifies the expression for ni such that it
  #then depends on doping (NA and ND). This is the "old Slotboom" model.
  #only "ni" is used elsewhere in the example this was pulled from
  source $ModelsDirectory/constants.tcl
  
  # calculate Nv
  set mp_lh [ expr 0.16 ]
  set mp_hh [ expr 0.7618 ]
  set Nv_lh [ expr 2*( ( $m0*$mp_lh*$k*$T )/( 2*$pi*$hbar**2) )**1.5 /100**3 ] ;# 1/cm^3
  set Nv_hh [ expr 2*( ( $m0*$mp_hh*$k*$T )/( 2*$pi*$hbar**2) )**1.5 /100**3 ] ;# 1/cm^3
  
  solution name=Hole_lh const solve    val= "$Nv_lh*F12((Qfp+Eval) /$Vt)"
  solution name=Hole_hh const solve    val= "$Nv_hh*F12((Qfp+Eval) /$Vt)"
  
  set eqnQfp "ddt(Hole) + Hmob * ( $Hmob_lh * Hole_lh + $Hmob_hh * Hole_hh ) * grad(Qfp)"
  
  pdbSetString Silicon Qfp    Equation $eqnQfp
  sel z= "Eval" name= Eval_edge
  
}

proc GetKPTemp { StressVector6 miller Vt {simp 0} } {

  set alpha [__approxFirstToSecondOrderRotation [ __MillerToRotation $miller ]]
  set S [ __Compliance (001)<100> Silicon ]
  set Strain [__MultAx $S [__MultAx $alpha $StressVector6 ]]
  
  if { $simp } {
    set kp [kp silicon simp GetParameters Xstrain= [lindex $Strain 0] Ystrain= [lindex $Strain 1] Zstrain= [lindex $Strain 2] YZstrain= [lindex $Strain 3] XZstrain= [lindex $Strain 4] XYstrain= [lindex $Strain 5] Vt= $Vt ]
  } else {
    set kp [kp silicon GetParameters Xstrain= [lindex $Strain 0] Ystrain= [lindex $Strain 1] Zstrain= [lindex $Strain 2] YZstrain= [lindex $Strain 3] XZstrain= [lindex $Strain 4] XYstrain= [lindex $Strain 5] Vt= $Vt ]
  }
  return $kp
}
proc GetKP { StressVector6 miller {simp 0} } {

  set alpha [__approxFirstToSecondOrderRotation [ __MillerToRotation $miller ]]
  set S [ __Compliance (001)<100> Silicon ]
  set Strain [__MultAx $S [__MultAx $alpha $StressVector6 ]]
  
  if { $simp } {
    set kp [kp silicon simp GetParameters Xstrain= [lindex $Strain 0] Ystrain= [lindex $Strain 1] Zstrain= [lindex $Strain 2] YZstrain= [lindex $Strain 3] XZstrain= [lindex $Strain 4] XYstrain= [lindex $Strain 5]]
  } else {
    set kp [kp silicon GetParameters Xstrain= [lindex $Strain 0] Ystrain= [lindex $Strain 1] Zstrain= [lindex $Strain 2] YZstrain= [lindex $Strain 3] XZstrain= [lindex $Strain 4] XYstrain= [lindex $Strain 5]]
  }
  return $kp
}

# This really doesn't work...
proc getHmobs0 { kp } {
  
  # Why the 1.5??
  #set Hmob_lhx [ expr 0.386/$mp_lhx*1.5 ]
  set LHMass 0.16
  set HHMass 0.49 ;# 0.7618 from DOS
  set SOMass 0.29
  set Mass [expr [Mathiessen Mobs= "$LHMass $HHMass $SOMass"]]
  puts [expr $Mass]
  puts [expr $LHMass/$Mass]
  
  set kp_LH_mx  [expr [lindex $kp 0 1]]
  set kp_LH_my  [expr [lindex $kp 0 2]]
  set kp_LH_mz  [expr [lindex $kp 0 3]]
  set kp_LH_myz [expr [lindex $kp 0 4]]
  set kp_LH_mxz [expr [lindex $kp 0 5]]
  set kp_LH_mxy [expr [lindex $kp 0 6]]
  
  set kp_HH_mx  [expr [lindex $kp 1 1]]
  set kp_HH_my  [expr [lindex $kp 1 2]]
  set kp_HH_mz  [expr [lindex $kp 1 3]]
  set kp_HH_myz [expr [lindex $kp 1 4]]
  set kp_HH_mxz [expr [lindex $kp 1 5]]
  set kp_HH_mxy [expr [lindex $kp 1 6]]
  
  set kp_SO_mx  [expr [lindex $kp 2 1]]
  set kp_SO_my  [expr [lindex $kp 2 2]]
  set kp_SO_mz  [expr [lindex $kp 2 3]]
  set kp_SO_myz [expr [lindex $kp 2 4]]
  set kp_SO_mxz [expr [lindex $kp 2 5]]
  set kp_SO_mxy [expr [lindex $kp 2 6]]
  
  set Hmob_lhx  [ expr $Mass/($LHMass*$kp_LH_mx) ]
  set Hmob_lhy  [ expr $Mass/($LHMass*$kp_LH_my) ]
  set Hmob_lhz  [ expr $Mass/($LHMass*$kp_LH_mz) ]
  set Hmob_lhyz [ expr $Mass/$LHMass*(1.0/$kp_LH_myz-1.0) ]
  set Hmob_lhxz [ expr $Mass/$LHMass*(1.0/$kp_LH_mxz-1.0) ]
  set Hmob_lhxy [ expr $Mass/$LHMass*(1.0/$kp_LH_mxy-1.0) ]
  
  set Hmob_hhx  [ expr $Mass/($HHMass*$kp_HH_mx) ]
  set Hmob_hhy  [ expr $Mass/($HHMass*$kp_HH_my) ]
  set Hmob_hhz  [ expr $Mass/($HHMass*$kp_HH_mz) ]
  set Hmob_hhyz [ expr $Mass/$HHMass*(1.0/$kp_HH_myz-1.0) ]
  set Hmob_hhxz [ expr $Mass/$HHMass*(1.0/$kp_HH_mxz-1.0) ]
  set Hmob_hhxy [ expr $Mass/$HHMass*(1.0/$kp_HH_mxy-1.0) ]
  
  set Hmob_lhyz 0.0
  set Hmob_lhxz 0.0
  set Hmob_lhxy 0.0
  set Hmob_hhyz 0.0
  set Hmob_hhxz 0.0
  set Hmob_hhxy 0.0
  
  set Hmob_sox  [ expr $Mass/(0.29*$kp_HH_mx) ]
  set Hmob_soy  [ expr $Mass/(0.29*$kp_HH_my) ]
  set Hmob_soz  [ expr $Mass/(0.29*$kp_HH_mz) ]
  #set Hmob_soyz [ expr 0.386/(0.29*$kp_HH_myz) ]
  #set Hmob_soxz [ expr 0.386/(0.29*$kp_HH_mxz) ]
  #set Hmob_soxy [ expr 0.386/(0.29*$kp_HH_mxy) ]
  
	return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz 0. 0. 0.\"
            \"$Hmob_hhx $Hmob_hhy $Hmob_hhz 0. 0. 0.\"
  \"$Hmob_sox $Hmob_soy $Hmob_soz 0. 0. 0.\""
  #return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz $Hmob_lhyz $Hmob_lhxz $Hmob_lhxy\"
  #        \"$Hmob_hhx $Hmob_hhy $Hmob_hhz $Hmob_hhyz $Hmob_hhxz $Hmob_hhxy\"
  #        \"$Hmob_sox $Hmob_soy $Hmob_soz $Hmob_soyz $Hmob_soxz $Hmob_soxy\""
  
  #	return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz $Hmob_lhyz $Hmob_lhxz $Hmob_lhxy\"
  #            \"$Hmob_hhx $Hmob_hhy $Hmob_hhz $Hmob_hhyz $Hmob_hhxz $Hmob_hhxy\""
  #            # "\"$Hmob_sox $Hmob_soy $Hmob_soz $Hmob_soyz $Hmob_soxz $Hmob_soxy\""
}
puts [getHmobs0 {{0. 1. 1. 1. 1. 1. 1. 0.} {0. 1. 1. 1. 1. 1. 1. 0.} {0. 1. 1. 1. 1. 1. 1. 0.}}]

proc getHmobs { kp } {
  
  set kp_LH_mx  ([lindex $kp 0 1])
  set kp_LH_my  ([lindex $kp 0 2])
  set kp_LH_mz  ([lindex $kp 0 3])
  set kp_LH_myz ([lindex $kp 0 4])
  set kp_LH_mxz ([lindex $kp 0 5])
  set kp_LH_mxy ([lindex $kp 0 6])
  
  set kp_HH_mx  ([lindex $kp 1 1])
  set kp_HH_my  ([lindex $kp 1 2])
  set kp_HH_mz  ([lindex $kp 1 3])
  set kp_HH_myz ([lindex $kp 1 4])
  set kp_HH_mxz ([lindex $kp 1 5])
  set kp_HH_mxy ([lindex $kp 1 6])
  
  set kp_SO_mx  ([lindex $kp 2 1])
  set kp_SO_my  ([lindex $kp 2 2])
  set kp_SO_mz  ([lindex $kp 2 3])
  set kp_SO_myz ([lindex $kp 2 4])
  set kp_SO_mxz ([lindex $kp 2 5])
  set kp_SO_mxy ([lindex $kp 2 6])

  set Mass (Hole/(LightHole/$kp_LH_mx+HeavyHole/$kp_HH_mx+SOHole/$kp_SO_mx))
  # set Mass [string map {Mx Mx0} $Mass]
  set Hmob_lhx  ($Mass/$kp_LH_mx)
  set Hmob_hhx  ($Mass/$kp_HH_mx)
  set Hmob_sox  ($Mass/$kp_SO_mx) 

  set Mass (Hole/(LightHole/$kp_LH_my+HeavyHole/$kp_HH_my+SOHole/$kp_SO_my))
  # set Mass [string map {My My0} $Mass]
  set Hmob_lhy  ($Mass/$kp_LH_my)
  set Hmob_hhy  ($Mass/$kp_HH_my)
  set Hmob_soy  ($Mass/$kp_SO_my) 

  set Mass (Hole/(LightHole/$kp_LH_mz+HeavyHole/$kp_HH_mz+SOHole/$kp_SO_mz))
  # set Mass [string map {Mz Mz0} $Mass]
  set Hmob_lhz  ($Mass/$kp_LH_mz)
  set Hmob_hhz  ($Mass/$kp_HH_mz)
  set Hmob_soz  ($Mass/$kp_SO_mz) 

  set Hmob_lhyz ($Mass/(1.0/$kp_LH_myz-1.0))
  set Hmob_lhxz ($Mass/(1.0/$kp_LH_mxz-1.0))
  set Hmob_lhxy ($Mass/(1.0/$kp_LH_mxy-1.0))
  set Hmob_hhyz ($Mass/(1.0/$kp_HH_myz-1.0))
  set Hmob_hhxz ($Mass/(1.0/$kp_HH_mxz-1.0))
  set Hmob_hhxy ($Mass/(1.0/$kp_HH_mxy-1.0))
  set Hmob_lhyz 0.0
  set Hmob_lhxz 0.0
  set Hmob_lhxy 0.0
  set Hmob_hhyz 0.0
  set Hmob_hhxz 0.0
  set Hmob_hhxy 0.0
  
  #set Hmob_soyz [ expr 0.386/(0.29*$kp_HH_myz) ]
  #set Hmob_soxz [ expr 0.386/(0.29*$kp_HH_mxz) ]
  #set Hmob_soxy [ expr 0.386/(0.29*$kp_HH_mxy) ]
  
	# return "\"1 1 1 0. 0. 0.\"
    #         \"1 1 1 0. 0. 0.\"
    # \"1 1 1 0. 0. 0.\""
	return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz 0. 0. 0.\"
            \"$Hmob_hhx $Hmob_hhy $Hmob_hhz 0. 0. 0.\"
  \"$Hmob_sox $Hmob_soy $Hmob_soz 0. 0. 0.\""
  #return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz $Hmob_lhyz $Hmob_lhxz $Hmob_lhxy\"
  #        \"$Hmob_hhx $Hmob_hhy $Hmob_hhz $Hmob_hhyz $Hmob_hhxz $Hmob_hhxy\"
  #        \"$Hmob_sox $Hmob_soy $Hmob_soz $Hmob_soyz $Hmob_soxz $Hmob_soxy\""
  
  #	return "\"$Hmob_lhx $Hmob_lhy $Hmob_lhz $Hmob_lhyz $Hmob_lhxz $Hmob_lhxy\"
  #            \"$Hmob_hhx $Hmob_hhy $Hmob_hhz $Hmob_hhyz $Hmob_hhxz $Hmob_hhxy\""
  #            # "\"$Hmob_sox $Hmob_soy $Hmob_soz $Hmob_soyz $Hmob_soxz $Hmob_soxy\""
}

proc Get3DHoleDPTensorZero { Holes miller } {
  set kp {{0. 1. 1. 1. 1. 1. 1. 0.} {0. 1. 1. 1. 1. 1. 1. 0.} {0. 1. 1. 1. 1. 1. 1. 0.}}
  set Hmobs [getHmobs0 $kp ]
  for { set i 0 } { $i < [llength $Holes] } { incr i } {
    set TenTmp [__RotateTensor [GetConductivityTensor [lindex $Hmobs $i ] [lindex $Holes $i] ] $miller]
    #set TenTmp1 [RotateTensor [GetMobilityTensor [lindex $Hmobs $i ] ] $CrystalRotation]
    #set TenTmp2 [RotateTensor [GetCarrierTensor  [lindex $Holes $i ] ] $CrystalRotation]
    #set TenTmp  [3DTensorMult $TenTmp1 $TenTmp2]
    lappend TensorList "[lindex $TenTmp 0]"
  }
  return [3DTensorAdd $TensorList]
  
}

#set kp    [GetKP $StressVector6 $StressRotation $CrystalRotation ]
proc Get3DHoleDPTensor { Holes kp miller } {
  set TensorList ""
  set Hmobs [getHmobs $kp ]
  for { set i 0 } { $i < [llength $Holes] } { incr i } {
    # set TenTmp [__RotateTensor [GetConductivityTensor [lindex $Hmobs $i ] [lindex $Holes $i] ] $miller]
    set TenTmp [GetConductivityTensor [lindex $Hmobs $i ] [lindex $Holes $i]]
    lappend TensorList "[lindex $TenTmp 0]"
  }
  return [3DTensorAdd $TensorList]
}

proc Get3DHoleDPTensor100 { XStressBool YStressBool } {
  
  set LHMass 0.16
  set HHMass 0.49 ;# 0.7618 from DOS
  set SOMass 0.29
  
  set Hmob_lhpar  [ expr 1.0/$LHMass ]
  set Hmob_lhperp [ expr 1.0/0.26 ]
  
  set Hmob_hhpar  [ expr 1.0/$HHMass ]
  set Hmob_hhperp [ expr 1.0/0.23 ]
  
  set Hmob_lhx  [ expr $XStressBool ? $Hmob_lhpar  : $YStressBool ? $Hmob_lhperp : $Hmob_lhperp ]
  puts [ expr $XStressBool ]
  puts [ expr $XStressBool ? $Hmob_lhpar  : $Hmob_lhperp ]
  puts [ expr $XStressBool ? $Hmob_lhpar  : $YStressBool ? $Hmob_lhperp : $Hmob_lhperp ]
  set Hmob_lhy  [ expr $XStressBool ? $Hmob_lhperp : $YStressBool ? $Hmob_lhpar  : $Hmob_lhperp ]
  set Hmob_lhz  [ expr $XStressBool ? $Hmob_lhperp : $YStressBool ? $Hmob_lhperp : $Hmob_lhpar ]
  
  set Hmob_hhx  [ expr $XStressBool ? $Hmob_hhpar  : $YStressBool ? $Hmob_hhperp : $Hmob_hhperp ]
  set Hmob_hhy  [ expr $XStressBool ? $Hmob_hhperp : $YStressBool ? $Hmob_hhpar  : $Hmob_hhperp ]
  set Hmob_hhz  [ expr $XStressBool ? $Hmob_hhperp : $YStressBool ? $Hmob_hhperp : $Hmob_hhpar ]
  puts [ expr $XStressBool ]
  puts [ expr $Hmob_hhpar  ]
  puts [ expr $Hmob_hhperp ]
  puts [ expr $XStressBool ? $Hmob_hhpar  : $Hmob_hhperp ]
  puts [ expr $XStressBool ? $Hmob_hhpar  : $YStressBool ? $Hmob_hhperp : $Hmob_hhperp ]
  
  
  set tmp ""
  lappend tmp "$Hmob_hhx*HeavyHole+$Hmob_lhx*LightHole 0 0"
  #lappend tmp "0 $Hmob_hhx*HeavyHole+$Hmob_lhx*LightHole 0"
  #lappend tmp "0 0 $Hmob_hhx*HeavyHole+$Hmob_lhx*LightHole"
  lappend tmp "0 $Hmob_hhy*HeavyHole+$Hmob_lhy*LightHole 0"
  lappend tmp "0 0 $Hmob_hhz*HeavyHole+$Hmob_lhz*LightHole"
  set Tensor ""
  lappend Tensor $tmp
  return $Tensor
}

proc ValanceBandEdgeShiftStress { kp } {
  return "[lindex $kp 0 0] [lindex $kp 1 0] [lindex $kp 2 0]"
}

proc ValanceBandDOSFactorStress { kp } {
  set NvLH [expr [lindex $kp 0 7]]
  set NvHH [expr [lindex $kp 1 7]]
  set NvSO [expr [lindex $kp 2 7]]
  return "$NvLH $NvHH $NvSO"
}



