
proc LinInterpMolFrac { a0 a1 MF } {
  return [ expr ($a0*(1-$MF)+$a1*$MF) ]
}

# linear interpolation of strain using the starting lattice constant
# and linearly interpolaring the change from the mole fraction
proc LatticeStrain { a0 a1 MF } {
  return [ expr $a0/([LinInterpMolFrac $a0 $a1 $MF]) - 1]
}


# set asi 5.429
# set age 5.657
# puts [format "%.2f" [expr [LatticeStrain $asi $age 0.15]/7.68e-12/1e6] ]
# puts [LinInterpMolFrac 1.1 0.74 0.15]









