
proc __TestReturn { bool } {
  if { [expr $bool] } {
    puts Passed
  } else {
    puts Failed
  }
}

proc PCErrorTest args {
  set name [lindex [info level 0] 0]
  lappend usage "$name val=? gold=? bound=1"
  lappend usage "The value (val) that was produced is needed"
  lappend usage "The authoritative gold standard value (gold) is needed"
  lappend usage "The percent error bound (bound) is assumed to be 1%"
  set returns "FEQF Ohmic Contact Current"
  set description {Computes the percent error for a test in against a gold value and returns if it is withing a bound (in percent).}
  if { [__Help $args $name $usage $returns $description] } {
    return ""
  }
  set val [__GetValue $args val "$name Error: no value (val) specified"]
  set gold [__GetValue $args gold "$name Error: no authoritative gold standard value (gold) specified"]
  set bound [__GetValue $args bound]
  if { $bound == "" } { 
    set bound 1
  }
  return [expr abs(($val)/($gold)-1.)*100. < 1.]
}

