
proc __alias {src tgt} {
    set nsrc [namespace qualifiers $src]
    set tsrc [namespace tail $src]
    set oe [uplevel 1 [list namespace eval $nsrc {namespace export}]]
    uplevel 1 [list namespace eval $nsrc {namespace export *}]
    set n 0
    while {[namespace exists tmp-[incr n]]} {}
    set fqsrc [uplevel 1 [list namespace which $src]]
    namespace eval tmp-$n [list namespace import $fqsrc]
    uplevel 1 [list rename [namespace which -command "tmp-${n}::$tsrc"] $tgt]
    uplevel 1 [list namespace eval $nsrc [list namespace export -clear {*}$oe]]
    namespace delete tmp-$n
}
proc aexpr e {
  set tmp [string map {^ **} $e]
  return [expr $tmp]
}

proc UtilProcs args {
  global ProcsDir FLXSHOME
  if { [expr [ string first -help $args ] != -1] } {
    return
  }
  set origProcs [info procs]
  if { [info exists ProcsDir] } {
    set FileDir $ProcsDir/Models/Utilities/
  } else {
    set FileDir $FLXSHOME/TclLib/Device/floods/Utilities/
  }
  uplevel 0 {source $FileDir/parse.tcl}
  uplevel 0 {source $FileDir/math.tcl}
  uplevel 0 {source $FileDir/basic.tcl}
  uplevel 0 {source $FileDir/comparestruct.tcl}

  uplevel 0 {source $FileDir/Interpolate/interpolate.tcl}
  
  uplevel 0 {source $FileDir/Optimize/penalty.tcl}
  uplevel 0 {source $FileDir/Optimize/optimize.tcl}
  uplevel 0 {source $FileDir/Optimize/optimize_slurm.tcl}
  
  uplevel 0 {source $FileDir/Strain/lattice.tcl}
  uplevel 0 {source $FileDir/Strain/XValley.tcl}
  uplevel 0 {source $FileDir/Strain/Kanda.tcl}
  uplevel 0 {source $FileDir/Strain/scalartensor.tcl}
  
  uplevel 0 {source $FileDir/Tensor/miller.tcl}
  uplevel 0 {source $FileDir/Tensor/tensor.tcl}
  uplevel 0 {source $FileDir/Tensor/rotations.tcl}
  
  uplevel 0 {source $FileDir/Bias/initial.tcl}
  uplevel 0 {source $FileDir/Bias/linear.tcl}
  uplevel 0 {source $FileDir/Bias/cache.tcl}
  uplevel 0 {source $FileDir/Bias/smooth.tcl}
  uplevel 0 {source $FileDir/Bias/continuation.tcl}
  uplevel 0 {source $FileDir/Bias/pod.tcl}

  uplevel 0 {source $FileDir/Testing/test.tcl}
  
  uplevel 0 {source $FileDir/search.tcl}
}

UtilProcs





