proc PC args {
  set name [lindex [info level 0] 0]
  lappend usage "PC value initial"
  set returns "number"
  set description "Computest the percent change from a value and the initial value."
  if { [__Help $args [lindex [info level 0] 0] $usage $returns $description] } {
    return ""
  }
  if {[llength $args] != 2} {
    puts "$name Error: Invalid Number of Arguments"
  }
  set v1 [lindex $args 0]
  set v0 [lindex $args 1]
  
  return [expr 100*(($v1)/($v0) - 1)]
}

proc __R args {
	set helpString "\u001b\[1m\u001b\[33mResistance calculation help:\u001b\[0m\n\
		  Usage: \[[lindex [info level 0] 0] Voltage Current \]\n\
      Returns: Resistance"
  if {[llength $args] != 2} {
    return -code error "\u001b\[1m\u001b\[31mInvalid Number of Arguments\u001b\[0m \n$helpString"
  }
  set V [lindex $args 0]
  set I [lindex $args 1]
  
  return [expr $V/$I]
}

proc Odr args {
  set name [lindex [info level 0] 0]
  lappend usage "$name value"
  set returns "number"
  set description "Computest the order of magnitude of a number."
  if { [__Help $args [lindex [info level 0] 0] $usage $returns $description] } {
    return ""
  }
  if {[llength $args] != 1} {
    puts "$name Error: Invalid Number of Arguments"
  }
  set v [lindex $args 0]
  return [expr ([string map {"-0" "-" "+0" "+"} [lindex [split [format "%e" [expr $v]] "e"] 1]])]
}

proc Rnd args {
  set name [lindex [info level 0] 0]
  lappend usage "$name value"
  set returns "number"
  set description "Computest the order of magnitude of a number."
  if { [__Help $args [lindex [info level 0] 0] $usage $returns $description] } {
    return ""
  }
  set sf 4
  if {[llength $args] == 2} {
    set sf [lindex $args 1]
  } elseif {[llength $args] != 1} {
    puts "$name Error: Invalid Number of Arguments. Got [llength $args] and expected 1 or 2"
    exit
  }
  set v [lindex $args 0]

  set sf [expr abs($sf)-1]
  set o [Odr $v]
  set p [expr 1./(10.**($o-$sf))]
  set nd [expr ($o-$sf) < 0 ? $sf-$o : 0]
  set newV [ expr round($v*$p)/$p ]
  set f f
  return [format "%.$nd$f" $newV]
}

