#This Procedures are helpers for the gui dialog boxes that we create

#Make the window
proc MakeWindow { w cmd hlp } {
    #make a top level window for the dialog box...
    catch {destroy $w}
    toplevel $w
    wm title $w "$cmd Entry"
    wm iconname $w "cmd Entry"
    
    #add a box at the bottom for accept/reject
	frame $w.buttons -bd 4 -relief groove
	pack $w.buttons -side bottom -anchor w -fill x
	button $w.buttons.accept -text Accept -command "
	    set ParamRetcode 1
	    destroy $w
	"
	button $w.buttons.cancel -text Cancel -command "
	    set ParamRetcode 0
	    destroy $w
	"
	pack $w.buttons.cancel -side left -anchor e -fill x
	pack $w.buttons.accept -side left -anchor w -fill x
    
    #add a title box with a help button
	frame $w.title -bd 4  -relief groove
	pack $w.title -side top -expand 1 -fill x

	label $w.title.name -text $cmd -anchor w
	pack $w.title.name -side left -anchor w -fill x

	button $w.title.help -text Help -anchor e -command "MakeHelpWin .help [list $cmd] $hlp"
	pack $w.title.help -side right -anchor e -fill x
}


proc MakeHelpWin { w cmd hlp } {
    puts "$w $cmd $hlp"

    #make a top level window for the dialog box...
    catch {destroy $w}
    toplevel $w
    wm title $w "Help Window for $cmd"
    wm iconname $w "Help $cmd"

    #add a button to make it go away
    frame $w.buttons -bd 2
    pack $w.buttons -side top -fill x
    button $w.buttons.dismiss -text Dismiss -command "destroy $w"
    pack $w.buttons.dismiss -side right -anchor e

    #add a text widget and scroll bar
    frame $w.display
    pack $w.display -side top
    text $w.display.text -yscrollcommand "$w.display.scroll set" -width 80 -height 20 
    scrollbar $w.display.scroll -command "$w.display.text yview"
    pack $w.display.scroll -side right -fill y
    pack $w.display.text -fill both -expand 1

    set id [open $hlp]
    $w.display.text delete 1.0 end
    $w.display.text insert 1.0 [read $id]
    close $id
    puts "$w $cmd $hlp $id"
}

proc MakeEntryInt { w labname varname hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    #make a label entry
    label $w.$varname.lab -text $labname -anchor w -width 15
    pack $w.$varname.lab -side left -anchor w 

    #make the entry field
    global $varname
    entry $w.$varname.ent -relief sunken -width 20 -textvariable $varname
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "Integer Field: $hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}

proc MakeEntryString { w labname varname hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    #make a label entry
    label $w.$varname.lab -text $labname -anchor w -width 15
    pack $w.$varname.lab -side left -anchor w 

    #make the entry field
    global $varname
    entry $w.$varname.ent -relief sunken -width 20 -textvariable $varname
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "String Field: $hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}

proc MakeEntryFile { w labname varname hlptxt } {
    #create a holder frame
    frame $w.varname -bd 2 
    pack $w.$varname -side top -fill x
}

proc MakeEntryFloat { w labname varname hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    #make a label entry
    label $w.$varname.lab -text $labname -anchor w -width 15
    pack $w.$varname.lab -side left -anchor w 

    #make the entry field
    global $varname
    entry $w.$varname.ent -relief sunken -width 20 -textvariable $varname
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "Float Field: $hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}

proc MakeEntryBool { w labname varname hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    #make the entry field
    global $varname
    checkbutton $w.$varname.ent -text $labname -variable $varname -anchor w -width 20
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "$hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}

proc MakeEntryArray { w labname varname hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    #make a label entry
    label $w.$varname.lab -text $labname -anchor w -width 15
    pack $w.$varname.lab -side left -anchor w 

    #make the entry field
    global $varname
    entry $w.$varname.ent -relief sunken -width 20 -textvariable $varname
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "Array Field: $hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}

proc MakeEntrySwitch { w varname options hlptxt } {
    #create a holder frame
    frame $w.$varname -bd 2 
    pack $w.$varname -side top -fill x

    upvar #0 $varname var
    set var [lindex $options 0]

    #make the entry field
    set m $w.$varname.ent
    menubutton $m -textvariable $varname -indicatoron 1 -menu $m.menu -width 15 \
	    -relief raised -bd 2 -highlightthickness 2 -anchor c -direction flush

    menu $m.menu -tearoff 0
    foreach i $options {
	$m.menu add radiobutton -label $i -variable $varname 
    }
    pack $w.$varname.ent -side left 

    #make the help text
    label $w.$varname.hlp -text "$hlptxt" -anchor w 
    pack $w.$varname.hlp -side left -anchor w -fill x
}
