proc CIEqn {Mat Sol} {}

proc CarbonEqn {Mat Sol} {
    set pM [pdbName $Mat]

    #compute the forward reaction rate between Sol and Ints
    set Dbase [pdbDelayDouble $pM Int D0]
    set Lspa [pdbDelayDouble $pM LatticeSpacing]
    set kf "(4.0 * 3.14159 * $Dbase * $Lspa)"

    set Bind [pdbDelayDouble $pM $Sol Bind]

    #build a term for a interstitial pairing
    puts "$kf $Bind"
    term name = ${Sol}I add eqn = "$kf * ($Sol * Int - $Bind * ${Sol}Int)"

    #build the forward reaction rate for Frank-Turnbull
    set DV [pdbDelayDouble $pM Vac D0]
    set DCI [pdbDelayDouble $pM ${Sol}Int D0]
    set Dbase "($DV + $DCI)"
    set Lspa [pdbDelayDouble $pM LatticeSpacing]
    set kf "(4.0 * 3.14159 * $Dbase * $Lspa)"

    #build reverse term
    set Crs [pdbDelayDouble $pM Vac Cstar]
    set Cbs [pdbDelayDouble $pM Int Cstar]
    set rat "($Cbs * $Crs / $Bind)"

    #add a term for Frank-Turnbull
    puts "$kf $rat"
    term name = ${Sol}V add eqn = "$kf * (${Sol}Int * Vac - $rat * ${Sol})"

    #add pieces to the int and vac equations
    set de [pdbGetString $pM Int Equation]
    pdbSetString $pM Int Equation "$de + ${Sol}I"

    set de [pdbGetString $pM Vac Equation]
    pdbSetString $pM Vac Equation "$de + ${Sol}V"

    #build an equation for Carbon
    pdbSetString $pM ${Sol} Equation "ddt(${Sol}) + ${Sol}I - ${Sol}V"

    #build an equation for CarbonInt
    set D0 [pdbDelayDouble $pM ${Sol}Int D0]
    set de "ddt(${Sol}Int) - ${Sol}I + ${Sol}V - $D0 * grad(${Sol}Int)" 
    pdbSetString $pM ${Sol}Int Equation $de
}
