proc Bestline {l} {
    set sumx 0.0
    set sumy 0.0
    set sum2x 0.0
    set sum2y 0.0
    set sumxy 0.0
    set num 0

    for {set i 0} {$i < [llength $l]/2} {incr i} {
	set x [lindex $l [expr 2*$i]]
	set y [lindex $l [expr 2*$i+1]]
	set sumx [expr $x + $sumx]
	set sum2x [expr $x * $x + $sum2x]
	set sumy [expr $y + $sumy]
	set sum2y [expr $y * $y + $sum2y]
	set sumxy [expr $x * $y + $sumxy]
	incr num
    }

    set denx [expr $num * $sum2x - $sumx * $sumx]
    set deny [expr $num * $sum2y - $sumy * $sumy]
    set top  [expr $num * $sumxy - $sumx * $sumy]

    set corr [expr $top / sqrt($denx * $deny)]
    set slp [expr $top / $denx]
    set inter [expr ($sumy - $sumx * $slp) / $num]

    return "$slp $inter $corr"
}

proc EaCalc {l} {
    set sumx 0.0
    set sumy 0.0
    set sum2x 0.0
    set sum2y 0.0
    set sumxy 0.0
    set num 0

    for {set i 0} {$i < [llength $l]/2} {incr i} {
	set x [lindex $l [expr 2*$i]]
	set y [lindex $l [expr 2*$i+1]]
	set x [expr 1.0 / (8.62e-5*($x+273.0))]
	set y [expr log($y)]
	set sumx [expr $x + $sumx]
	set sum2x [expr $x * $x + $sum2x]
	set sumy [expr $y + $sumy]
	set sum2y [expr $y * $y + $sum2y]
	set sumxy [expr $x * $y + $sumxy]
	incr num
    }

    set denx [expr $num * $sum2x - $sumx * $sumx]
    set deny [expr $num * $sum2y - $sumy * $sumy]
    set top  [expr $num * $sumxy - $sumx * $sumy]

    set corr [expr $top / sqrt($denx * $deny)]
    set slp [expr $top / $denx]
    set inter [expr ($sumy - $sumx * $slp) / $num]

    return "[expr -$slp] [expr exp($inter)] $corr"
}


proc Decay {l} {
    set sumx 0.0
    set sumy 0.0
    set sum2x 0.0
    set sum2y 0.0
    set sumxy 0.0
    set num 0

    for {set i 0} {$i < [llength $l]/2} {incr i} {
	set x [lindex $l [expr 2*$i]]
	set y [lindex $l [expr 2*$i+1]]
	set y [expr log($y)]
	set sumx [expr $x + $sumx]
	set sum2x [expr $x * $x + $sum2x]
	set sumy [expr $y + $sumy]
	set sum2y [expr $y * $y + $sum2y]
	set sumxy [expr $x * $y + $sumxy]
	incr num
    }

    set denx [expr $num * $sum2x - $sumx * $sumx]
    set deny [expr $num * $sum2y - $sumy * $sumy]
    set top  [expr $num * $sumxy - $sumx * $sumy]

    set corr [expr $top / sqrt($denx * $deny)]
    set slp [expr $top / $denx]
    set inter [expr ($sumy - $sumx * $slp) / $num]

    return "[expr -1.0/$slp] [expr exp($inter)] $corr"
}


proc StatXY {l} {
    set sumy 0.0
    set sumx 0.0
    set stdx 0
    set stdy 0
    set num 0

    #compute the mean of the data
    for {set i 0} {$i < [llength $l]/2} {incr i} {
	set x [lindex $l [expr 2*$i]]
	set y [lindex $l [expr 2*$i+1]]
	set sumx [expr $sumx + $x]
	set sumy [expr $sumy + $y]
	incr num
    }
    set meanx [expr $sumx / $num]
    set meany [expr $sumy / $num]

    for {set i 0} {$i < [llength $l]/2} {incr i} {
	set x [lindex $l [expr 2*$i]]
	set y [lindex $l [expr 2*$i+1]]
	set stdx [expr $stdx + ($x - $meanx)*($x - $meanx)]
	set stdy [expr $stdy + ($y - $meany)*($y - $meany)]
	incr num
    }
    set stdx [expr sqrt( $stdx / $num )]
    set stdy [expr sqrt( $stdy / $num )]

    return "$meanx $stdx $meany $stdy"
}


proc Stats {l} {
    set sumx 0.0
    set num 0

    #compute the mean of the data
    foreach pair $l {
	set sumx [expr $sumx + $pair]
	incr num
    }
    set mean [expr $sumx / $num]

    set std 0
    foreach pair $l {
	set std [expr $std + ($pair - $mean)*($pair - $mean)]
	incr num
    }
    set std [expr sqrt( $std / $num )]

    return "$mean $std"
}



proc FindDose {inp} {
    set ll [layers]
    set ret 0.0
    foreach line $ll {
	set dose [lindex $line 2]
	set mat [lindex $line 3]
	if {$mat == $inp} {
	    if {$dose > 0.0} {set ret [expr $ret + $dose]}
	}
    }
    return $ret
}


